<div class="table">
  <table
    mat-table
    [dataSource]="data?.elements"
    matSort
    [matSortActive]="queryParams.orderBy"
    [matSortDirection]="queryParams.orderDirection">
    <!-- actions Column -->
    <ng-container *ngIf="actions" matColumnDef="actions">
      <th mat-header-cell *matHeaderCellDef>Взаємодія</th>
      <td mat-cell *matCellDef="let row">
        <div class="buttons-group">
          <button
            *ngIf="actions[TABLE_ACTIONS.Edit] as action"
            (click)="edited.emit(row)"
            [matTooltip]="action.tooltip || 'Редагувати'"
            [matTooltipPosition]="action.tooltipPosition || 'above'"
            mat-icon-button>
            <mat-icon>edit</mat-icon>
          </button>
          <button
            *ngIf="actions[TABLE_ACTIONS.Delete] as action"
            [matTooltip]="action.tooltip || 'Видалити'"
            [matTooltipPosition]="action.tooltipPosition || 'above'"
            (click)="deleted.emit(row)"
            mat-icon-button>
            <mat-icon>delete</mat-icon>
          </button>
        </div>
      </td>
    </ng-container>

    <ng-container
      *ngFor="let column of columns; trackBy: trackByColumns"
      [matColumnDef]="column.name">
      <ng-container *ngIf="column.sortHeader; else defaultHeader">
        <th mat-header-cell mat-sort-header disableClear *matHeaderCellDef>
          {{ column.label }}
        </th>
      </ng-container>
      <ng-template #defaultHeader>
        <th mat-header-cell *matHeaderCellDef>
          {{ column.label }}
        </th>
      </ng-template>
      <ng-template #headerLabel></ng-template>
      <td mat-cell *matCellDef="let row">
        <ng-container *ngIf="column.component as componentType; else internal">
          <ng-template
            *rdnInsertComponent="
              componentType.class;
              data: row
                | cellComponentInputs: row[column.name] : componentType.inputs
            "></ng-template>
        </ng-container>
        <ng-template #internal>
          <ng-container
            *ngIf="column.valueAdapter as adapter; else defaultTemplate">
            {{ row[column.name] | valueAdapter: adapter : row }}
          </ng-container>
          <ng-template #defaultTemplate>
            {{ row[column.name] || '-//-' }}
          </ng-template>
        </ng-template>
      </td>
    </ng-container>

    <tr mat-header-row *matHeaderRowDef="displayedColumns"></tr>
    <tr mat-row *matRowDef="let row; columns: displayedColumns"></tr>
  </table>
</div>
<mat-paginator
  [pageSizeOptions]="pageSizeOptions"
  [pageIndex]="queryParams.pageNumber - 1"
  [length]="data?.totalElements"
  [pageSize]="queryParams.pageSize"></mat-paginator>
